Index: CKEditor/branches/versions/3.5.x/CHANGES.html
===================================================================
--- CKEditor/branches/versions/3.5.x/CHANGES.html	(revision 5916)
+++ CKEditor/branches/versions/3.5.x/CHANGES.html	(revision 5930)
@@ -46,5 +46,6 @@
 			Fixed issues:</p>
 	<ul>
-		<li><a href="http://dev.ckeditor.com/ticket/4821">#4821</a> : Icons in the toolbar were distorted with IE and zoom != 100%</li>
+		<li><a href="http://dev.ckeditor.com/ticket/4821">#4821</a> : Icons in the toolbar were distorted with IE and zoom != 100%.</li>
+		<li><a href="http://dev.ckeditor.com/ticket/5587">#5587</a> : Visual improvements in dialogs.</li>
 		<li>Updated the following language files:<ul>
 			<li>Hebrew;</li>
Index: CKEditor/branches/versions/3.5.x/_source/plugins/image/dialogs/image.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/image/dialogs/image.js	(revision 5916)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/image/dialogs/image.js	(revision 5930)
@@ -802,5 +802,4 @@
 													id : 'txtBorder',
 													width: '60px',
-													labelLayout : 'horizontal',
 													label : editor.lang.image.border,
 													'default' : '',
@@ -859,5 +858,4 @@
 													id : 'txtHSpace',
 													width: '60px',
-													labelLayout : 'horizontal',
 													label : editor.lang.image.hSpace,
 													'default' : '',
@@ -923,5 +921,4 @@
 													id : 'txtVSpace',
 													width : '60px',
-													labelLayout : 'horizontal',
 													label : editor.lang.image.vSpace,
 													'default' : '',
@@ -985,5 +982,4 @@
 													id : 'cmbAlign',
 													type : 'select',
-													labelLayout : 'horizontal',
 													widths : [ '35%','65%' ],
 													style : 'width:90px',
Index: CKEditor/branches/versions/3.5.x/_source/plugins/link/dialogs/link.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/link/dialogs/link.js	(revision 5916)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/link/dialogs/link.js	(revision 5930)
@@ -790,5 +790,5 @@
 					{
 						type : 'vbox',
-						width : 260,
+						width : '100%',
 						align : 'center',
 						padding : 2,
@@ -894,5 +894,5 @@
 											{
 												type :  'text',
-												widths : [ '30%', '70%' ],
+												widths : [ '50%', '50%' ],
 												labelLayout : 'horizontal',
 												label : editor.lang.link.popupWidth,
@@ -905,5 +905,5 @@
 												type :  'text',
 												labelLayout : 'horizontal',
-												widths : [ '55%', '45%' ],
+												widths : [ '50%', '50%' ],
 												label : editor.lang.link.popupLeft,
 												id : 'left',
@@ -921,5 +921,5 @@
 												type :  'text',
 												labelLayout : 'horizontal',
-												widths : [ '30%', '70%' ],
+												widths : [ '50%', '50%' ],
 												label : editor.lang.link.popupHeight,
 												id : 'height',
@@ -932,5 +932,5 @@
 												labelLayout : 'horizontal',
 												label : editor.lang.link.popupTop,
-												widths : [ '55%', '45%' ],
+												widths : [ '50%', '50%' ],
 												id : 'top',
 												setup : setupPopupParams,
Index: CKEditor/branches/versions/3.5.x/_source/plugins/tabletools/dialogs/tableCell.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/tabletools/dialogs/tableCell.js	(revision 5916)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/tabletools/dialogs/tableCell.js	(revision 5930)
@@ -13,5 +13,6 @@
 			heightPattern = /^(\d+(?:\.\d+)?)px$/,
 			bind = CKEDITOR.tools.bind,
-			spacer = { type : 'html', html : '&nbsp;' };
+			spacer = { type : 'html', html : '&nbsp;' },
+			rtl = editor.lang.dir == 'rtl';
 
 		/**
@@ -244,7 +245,5 @@
 											type : 'select',
 											id : 'hAlign',
-											labelLayout : 'horizontal',
 											label : langCell.hAlign,
-											widths : [ '50%', '50%' ],
 											'default' : '',
 											items :
@@ -277,7 +276,5 @@
 											type : 'select',
 											id : 'vAlign',
-											labelLayout : 'horizontal',
 											label : langCell.vAlign,
-											widths : [ '50%', '50%' ],
 											'default' : '',
 											items :
@@ -400,5 +397,5 @@
 											type : 'hbox',
 											padding : 0,
-											widths : [ '80%', '20%' ],
+											widths : [ '70%', '30%' ],
 											children :
 											[
@@ -407,6 +404,4 @@
 													id : 'bgColor',
 													label : langCell.bgColor,
-													labelLayout : 'horizontal',
-													widths : [ '70%', '30%' ],
 													'default' : '',
 													setup : function( element )
@@ -433,5 +428,10 @@
 													id : 'bgColorChoose',
 													label : langCell.chooseColor,
-													style : 'margin-left: 10px',
+													style : ( rtl ? 'margin-right' : 'margin-left' ) + ': 10px',
+													onLoad : function()
+													{
+														// Stick the element to the bottom (#5587)
+														this.getElement().getParent().setStyle( 'vertical-align', 'bottom' );
+													},
 													onClick : function()
 													{
@@ -451,5 +451,5 @@
 											type : 'hbox',
 											padding : 0,
-											widths : [ '80%', '20%' ],
+											widths : [ '70%', '30%' ],
 											children :
 											[
@@ -458,6 +458,4 @@
 													id : 'borderColor',
 													label : langCell.borderColor,
-													labelLayout : 'horizontal',
-													widths : [ '70%', '30%' ],
 													'default' : '',
 													setup : function( element )
@@ -483,5 +481,10 @@
 													id : 'borderColorChoose',
 													label : langCell.chooseColor,
-													style : 'margin-left: 10px',
+													style : ( rtl ? 'margin-right' : 'margin-left' ) + ': 10px',
+													onLoad : function()
+													{
+														// Stick the element to the bottom (#5587)
+														this.getElement().getParent().setStyle( 'vertical-align', 'bottom' );
+													},
 													onClick : function()
 													{