Index: CKEditor/trunk/CHANGES.html
===================================================================
--- CKEditor/trunk/CHANGES.html	(revision 5974)
+++ CKEditor/trunk/CHANGES.html	(revision 5975)
@@ -146,4 +146,5 @@
 		<li><a href="http://dev.ckeditor.com/ticket/5595">#5595</a> : Extra leading spaces added in preformatted block.</li>
 		<li><a href="http://dev.ckeditor.com/ticket/6094">#6094</a> : Match full word option doesn't stop on block boundaries.</li>
+		<li><a href="http://dev.ckeditor.com/ticket/6087">#6087</a> : Cursor of input fields in dialog isn't visible in RLT .</li>
 		<li>Updated the following language files:<ul>
 			<li><a href="http://dev.ckeditor.com/ticket/6246">#6246</a> : Chinese Simplified;</li>
Index: CKEditor/trunk/_source/skins/kama/dialog.css
===================================================================
--- CKEditor/trunk/_source/skins/kama/dialog.css	(revision 5974)
+++ CKEditor/trunk/_source/skins/kama/dialog.css	(revision 5975)
@@ -240,4 +240,22 @@
 }
 
+/* Opera/IE doesn't leave enough padding in text input for cursor to blink in RTL. (#6087) */
+.cke_skin_kama .cke_browser_ie.cke_rtl input.cke_dialog_ui_input_text,
+.cke_skin_kama .cke_browser_opera.cke_rtl input.cke_dialog_ui_input_text,
+.cke_skin_kama .cke_browser_ie.cke_rtl input.cke_dialog_ui_input_password,
+.cke_skin_kama .cke_browser_opera.cke_rtl input.cke_dialog_ui_input_password
+{
+	padding-right: 2px
+}
+
+/* Compensate the padding added above on container. */
+.cke_skin_kama .cke_browser_ie.cke_rtl div.cke_dialog_ui_input_text,
+.cke_skin_kama .cke_browser_opera.cke_rtl div.cke_dialog_ui_input_text,
+.cke_skin_kama .cke_browser_ie.cke_rtl div.cke_dialog_ui_input_password,
+.cke_skin_kama .cke_browser_opera.cke_rtl div.cke_dialog_ui_input_password
+{
+	padding-left: 2px;
+}
+
 .cke_skin_kama .cke_browser_ie.cke_rtl div.cke_dialog_ui_input_text {
 	padding-right: 1px;
Index: CKEditor/trunk/_source/skins/office2003/dialog.css
===================================================================
--- CKEditor/trunk/_source/skins/office2003/dialog.css	(revision 5974)
+++ CKEditor/trunk/_source/skins/office2003/dialog.css	(revision 5975)
@@ -328,4 +328,22 @@
 }
 
+/* Opera/IE doesn't leave enough padding in text input for cursor to blink in RTL. (#6087) */
+.cke_skin_office2003 .cke_browser_ie.cke_rtl input.cke_dialog_ui_input_text,
+.cke_skin_office2003 .cke_browser_opera.cke_rtl input.cke_dialog_ui_input_text,
+.cke_skin_office2003 .cke_browser_ie.cke_rtl input.cke_dialog_ui_input_password,
+.cke_skin_office2003 .cke_browser_opera.cke_rtl input.cke_dialog_ui_input_password
+{
+	padding-right: 2px
+}
+
+/* Compensate the padding added above on container. */
+.cke_skin_office2003 .cke_browser_ie.cke_rtl div.cke_dialog_ui_input_text,
+.cke_skin_office2003 .cke_browser_opera.cke_rtl div.cke_dialog_ui_input_text,
+.cke_skin_office2003 .cke_browser_ie.cke_rtl div.cke_dialog_ui_input_password,
+.cke_skin_office2003 .cke_browser_opera.cke_rtl div.cke_dialog_ui_input_password
+{
+	padding-left: 2px;
+}
+
 .cke_skin_office2003 .cke_browser_ie.cke_rtl div.cke_dialog_ui_input_text {
 	padding-right: 1px;
Index: CKEditor/trunk/_source/skins/v2/dialog.css
===================================================================
--- CKEditor/trunk/_source/skins/v2/dialog.css	(revision 5974)
+++ CKEditor/trunk/_source/skins/v2/dialog.css	(revision 5975)
@@ -329,4 +329,22 @@
 {
 	border-width: 1px;
+}
+
+/* Opera/IE doesn't leave enough padding in text input for cursor to blink in RTL. (#6087) */
+.cke_skin_v2 .cke_browser_ie.cke_rtl input.cke_dialog_ui_input_text,
+.cke_skin_v2 .cke_browser_opera.cke_rtl input.cke_dialog_ui_input_text,
+.cke_skin_v2 .cke_browser_ie.cke_rtl input.cke_dialog_ui_input_password,
+.cke_skin_v2 .cke_browser_opera.cke_rtl input.cke_dialog_ui_input_password
+{
+	padding-right: 2px
+}
+
+/* Compensate the padding added above on container. */
+.cke_skin_v2 .cke_browser_ie.cke_rtl div.cke_dialog_ui_input_text,
+.cke_skin_v2 .cke_browser_opera.cke_rtl div.cke_dialog_ui_input_text,
+.cke_skin_v2 .cke_browser_ie.cke_rtl div.cke_dialog_ui_input_password,
+.cke_skin_v2 .cke_browser_opera.cke_rtl div.cke_dialog_ui_input_password
+{
+	padding-left: 2px;
 }
 