Index: CKEditor/trunk/_source/core/_bootstrap.js
===================================================================
--- CKEditor/trunk/_source/core/_bootstrap.js	(revision 5979)
+++ CKEditor/trunk/_source/core/_bootstrap.js	(revision 5980)
@@ -86,4 +86,12 @@
 
 /**
+ * Indicates that CKEditor is running on a High Contrast environment.
+ * @name CKEDITOR.env.hc
+ * @example
+ * if ( CKEDITOR.env.hc )
+ *     alert( 'You're running on High Contrast mode. The editor interface will get adapted to provide you a better experience.' );
+ */
+
+/**
  * Fired when a CKEDITOR core object is fully loaded and ready for interaction.
  * @name CKEDITOR#loaded
Index: CKEditor/trunk/_source/core/ckeditor.js
===================================================================
--- CKEditor/trunk/_source/core/ckeditor.js	(revision 5979)
+++ CKEditor/trunk/_source/core/ckeditor.js	(revision 5980)
@@ -107,7 +107,27 @@
 
 /**
+ * The editor which is currently active (have user focus).
+ * @name CKEDITOR.currentInstance
+ * @type CKEDITOR.editor
+ * @see CKEDITOR#currentInstance
+ * @example
+ * function showCurrentEditorName()
+ * {
+ *     if ( CKEDITOR.currentInstance )
+ *         alert( CKEDITOR.currentInstance.name );
+ *     else
+ *         alert( 'Please focus an editor first.' );
+ * }
+ */
+
+/**
  * Fired when the CKEDITOR.currentInstance object reference changes. This may
  * happen when setting the focus on different editor instances in the page.
  * @name CKEDITOR#currentInstance
  * @event
+ * var editor;  // Variable to hold a reference to the current editor.
+ * CKEDITOR.on( 'currentInstance' , function( e )
+ *     {
+ *         editor = CKEDITOR.currentInstance;
+ *     });
  */
Index: CKEditor/trunk/_source/core/ckeditor_base.js
===================================================================
--- CKEditor/trunk/_source/core/ckeditor_base.js	(revision 5979)
+++ CKEditor/trunk/_source/core/ckeditor_base.js	(revision 5980)
@@ -53,5 +53,5 @@
 			 * @type String
 			 * @example
-			 * alert( CKEDITOR.version );  // e.g. 'CKEditor 3.0 Beta'
+			 * alert( CKEDITOR.version );  // e.g. 'CKEditor 3.4.1'
 			 */
 			version : '%VERSION%',
@@ -59,5 +59,6 @@
 			/**
 			 * Contains the CKEditor revision number.
-			 * Revision number is incremented automatically after each modification of CKEditor source code.
+			 * The revision number is incremented automatically, following each
+			 * modification to the CKEditor source code.
 			 * @type String
 			 * @example
@@ -146,10 +147,13 @@
 			 * Gets the full URL for CKEditor resources. By default, URLs
 			 * returned by this function contains a querystring parameter ("t")
-			 * set to the {@link CKEDITOR.timestamp} value.
+			 * set to the {@link CKEDITOR.timestamp} value.<br />
+			 * <br />
 			 * It's possible to provide a custom implementation to this
 			 * function by setting a global variable named CKEDITOR_GETURL.
 			 * This global variable must be set "before" the editor script
-			 * loading. If the custom implementation returns nothing, the
+			 * loading. If the custom implementation returns nothing (==null), the
 			 * default implementation is used.
+			 * @param {String} resource The resource to which get the full URL.
+			 *		It may be a full, absolute or relative URL.
 			 * @returns {String} The full URL.
 			 * @example
Index: CKEditor/trunk/_source/core/dom/range.js
===================================================================
--- CKEditor/trunk/_source/core/dom/range.js	(revision 5979)
+++ CKEditor/trunk/_source/core/dom/range.js	(revision 5980)
@@ -1865,16 +1865,12 @@
 CKEDITOR.ENLARGE_LIST_ITEM_CONTENTS = 3;
 
-/**
- * Check boundary types.
- * @see CKEDITOR.dom.range.prototype.checkBoundaryOfElement
- */
+// Check boundary types.
+// @see CKEDITOR.dom.range.prototype.checkBoundaryOfElement
 CKEDITOR.START = 1;
 CKEDITOR.END = 2;
 CKEDITOR.STARTEND = 3;
 
-/**
- * Shrink range types.
- * @see CKEDITOR.dom.range.prototype.shrink
- */
+// Shrink range types.
+// @see CKEDITOR.dom.range.prototype.shrink
 CKEDITOR.SHRINK_ELEMENT = 1;
 CKEDITOR.SHRINK_TEXT = 2;