Index: CKEditor/trunk/_source/core/ckeditor_basic.js
===================================================================
--- CKEditor/trunk/_source/core/ckeditor_basic.js	(revision 5984)
+++ CKEditor/trunk/_source/core/ckeditor_basic.js	(revision 5985)
@@ -30,5 +30,5 @@
 			if ( CKEDITOR.status != 'basic_ready' )
 			{
-				CKEDITOR.loadFullCore._load = true;
+				CKEDITOR.loadFullCore._load = 1;
 				return;
 			}
@@ -79,5 +79,5 @@
 		 * <b>CKEDITOR.replaceByClassEnabled</b> = false;
 		 */
-		CKEDITOR.replaceByClassEnabled = true;
+		CKEDITOR.replaceByClassEnabled = 1;
 
 		var createInstance = function( elementOrIdOrName, config, creationFunction, data )
@@ -176,7 +176,7 @@
 			for ( var i = 0 ; i < textareas.length ; i++ )
 			{
-				var config = null;
-				var textarea = textareas[i];
-				var name = textarea.name;
+				var config = null,
+					textarea = textareas[i],
+					name = textarea.name;
 
 				// The "name" and/or "id" attribute must exist.
Index: CKEditor/trunk/_source/core/command.js
===================================================================
--- CKEditor/trunk/_source/core/command.js	(revision 5984)
+++ CKEditor/trunk/_source/core/command.js	(revision 5985)
@@ -82,5 +82,5 @@
 			 * command.<b>editorFocus</b> = false;
 			 */
-			editorFocus : true,
+			editorFocus : 1,
 
 			/**
Index: CKEditor/trunk/_source/core/dom/element.js
===================================================================
--- CKEditor/trunk/_source/core/dom/element.js	(revision 5984)
+++ CKEditor/trunk/_source/core/dom/element.js	(revision 5985)
@@ -89,5 +89,5 @@
 {
 	for ( var i in database )
-		CKEDITOR.dom.element.clearMarkers( database, database[i], true );
+		CKEDITOR.dom.element.clearMarkers( database, database[i], 1 );
 };
 
@@ -1171,5 +1171,5 @@
 				{
 					this.$.style.MozUserSelect = 'none';
-					this.on( 'dragstart', function (evt) { evt.data.preventDefault(); } );
+					this.on( 'dragstart', function( evt ) { evt.data.preventDefault(); } );
 				}
 			: CKEDITOR.env.webkit ?
@@ -1177,5 +1177,5 @@
 				{
 					this.$.style.KhtmlUserSelect = 'none';
-					this.on( 'dragstart', function (evt) { evt.data.preventDefault(); } );
+					this.on( 'dragstart', function( evt ) { evt.data.preventDefault(); } );
 				}
 			:
@@ -1546,5 +1546,5 @@
 						{
 							var	adjustment = 0;
-							for ( var i = 0, len = sides [ type ].length; i < len; i++ )
+							for ( var i = 0, len = sides[ type ].length; i < len; i++ )
 								adjustment += parseInt( this.getComputedStyle( sides [ type ][ i ] ) || 0, 10 ) || 0;
 							size -= adjustment;
Index: CKEditor/trunk/_source/core/dom/walker.js
===================================================================
--- CKEditor/trunk/_source/core/dom/walker.js	(revision 5984)
+++ CKEditor/trunk/_source/core/dom/walker.js	(revision 5985)
@@ -262,5 +262,5 @@
 			previous : function()
 			{
-				return iterate.call( this, true );
+				return iterate.call( this, 1 );
 			},
 
@@ -272,5 +272,5 @@
 			checkForward : function()
 			{
-				return iterate.call( this, false, true ) !== false;
+				return iterate.call( this, 0, 1 ) !== false;
 			},
 
@@ -282,5 +282,5 @@
 			checkBackward : function()
 			{
-				return iterate.call( this, true, true ) !== false;
+				return iterate.call( this, 1, 1 ) !== false;
 			},
 
@@ -304,5 +304,5 @@
 			lastBackward : function()
 			{
-				return iterateToLast.call( this, true );
+				return iterateToLast.call( this, 1 );
 			},
 
@@ -375,5 +375,5 @@
 			return ( node && node.getName
 					&& node.getName() == 'span'
-					&& node.hasAttribute('_cke_bookmark') );
+					&& node.hasAttribute( '_cke_bookmark' ) );
 		}
 
@@ -424,6 +424,6 @@
 
 	var tailNbspRegex = /^[\t\r\n ]*(?:&nbsp;|\xa0)$/,
-		isNotWhitespaces = CKEDITOR.dom.walker.whitespaces( true ),
-		isNotBookmark = CKEDITOR.dom.walker.bookmark( false, true ),
+		isNotWhitespaces = CKEDITOR.dom.walker.whitespaces( 1 ),
+		isNotBookmark = CKEDITOR.dom.walker.bookmark( 0, 1 ),
 		fillerEvaluator = function( element )
 		{
@@ -432,5 +432,5 @@
 
 	// Check if there's a filler node at the end of an element, and return it.
-	CKEDITOR.dom.element.prototype.getBogus = function ()
+	CKEDITOR.dom.element.prototype.getBogus = function()
 	{
 		var tail = this.getLast( fillerEvaluator );
Index: CKEditor/trunk/_source/core/skins.js
===================================================================
--- CKEditor/trunk/_source/core/skins.js	(revision 5984)
+++ CKEditor/trunk/_source/core/skins.js	(revision 5985)
@@ -17,7 +17,7 @@
 {
 	// Holds the list of loaded skins.
-	var loaded = {};
-	var preloaded = {};
-	var paths = {};
+	var loaded = {},
+		preloaded = {},
+		paths = {};
 
 	var loadPart = function( editor, skinName, part, callback )
@@ -102,6 +102,6 @@
 			// Check whether the "css" and "js" properties have been defined
 			// for that part.
-			var cssIsLoaded = !part.css || !part.css.length;
-			var jsIsLoaded = !part.js || !part.js.length;
+			var cssIsLoaded = !part.css || !part.css.length,
+				jsIsLoaded = !part.js || !part.js.length;
 
 			// This is the function that will trigger the callback calls on
Index: CKEditor/trunk/_source/plugins/htmldataprocessor/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/htmldataprocessor/plugin.js	(revision 5984)
+++ CKEditor/trunk/_source/plugins/htmldataprocessor/plugin.js	(revision 5985)
@@ -501,3 +501,2 @@
  * config.forceSimpleAmpersand = false;
  */
-CKEDITOR.config.forceSimpleAmpersand = false;
Index: CKEditor/trunk/_source/plugins/htmlwriter/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/htmlwriter/plugin.js	(revision 5984)
+++ CKEditor/trunk/_source/plugins/htmlwriter/plugin.js	(revision 5985)
@@ -74,9 +74,9 @@
 			this.setRules( e,
 				{
-					indent : true,
-					breakBeforeOpen : true,
-					breakAfterOpen : true,
+					indent : 1,
+					breakBeforeOpen : 1,
+					breakAfterOpen : 1,
 					breakBeforeClose : !dtd[ e ][ '#' ],
-					breakAfterClose : true
+					breakAfterClose : 1
 				});
 		}
@@ -84,17 +84,17 @@
 		this.setRules( 'br',
 			{
-				breakAfterOpen : true
+				breakAfterOpen : 1
 			});
 
 		this.setRules( 'title',
 			{
-				indent : false,
-				breakAfterOpen : false
+				indent : 0,
+				breakAfterOpen : 0
 			});
 
 		this.setRules( 'style',
 			{
-				indent : false,
-				breakBeforeClose : true
+				indent : 0,
+				breakBeforeClose : 1
 			});
 
@@ -102,5 +102,5 @@
 		this.setRules( 'pre',
 			{
-			  indent: false
+			  indent : 0
 			});
 	},
Index: CKEditor/trunk/_source/plugins/indent/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/indent/plugin.js	(revision 5984)
+++ CKEditor/trunk/_source/plugins/indent/plugin.js	(revision 5985)
@@ -261,5 +261,6 @@
 					if ( isNaN( currentOffset ) )
 						currentOffset = 0;
-					currentOffset += ( self.name == 'indent' ? 1 : -1 ) * editor.config.indentOffset;
+					var indentOffset = indentOffset || 40;
+					currentOffset += ( self.name == 'indent' ? 1 : -1 ) * indentOffset;
 
 					if ( currentOffset < 0 )
@@ -267,5 +268,5 @@
 
 					currentOffset = Math.max( currentOffset, 0 );
-					currentOffset = Math.ceil( currentOffset / editor.config.indentOffset ) * editor.config.indentOffset;
+					currentOffset = Math.ceil( currentOffset / indentOffset ) * indentOffset;
 					element.setStyle( indentCssProperty, currentOffset ? currentOffset + ( editor.config.indentUnit || 'px' ) : '' );
 					if ( element.getAttribute( 'style' ) === '' )
@@ -273,14 +274,14 @@
 				}
 
-				CKEDITOR.dom.element.setMarker( database, element, 'indent_processed', true );
+				CKEDITOR.dom.element.setMarker( database, element, 'indent_processed', 1 );
 				return true;
 			}
 
 			var selection = editor.getSelection(),
-				bookmarks = selection.createBookmarks( true ),
-				ranges = selection && selection.getRanges( true ),
+				bookmarks = selection.createBookmarks( 1 ),
+				ranges = selection && selection.getRanges( 1 ),
 				range;
 
-			var skipBookmarks = CKEDITOR.dom.walker.bookmark( false, true );
+			var skipBookmarks = CKEDITOR.dom.walker.bookmark( 0, 1 );
 
 			var iterator = ranges.createIterator();
@@ -421,9 +422,4 @@
 })();
 
-CKEDITOR.tools.extend( CKEDITOR.config,
-	{
-		indentOffset : 40
-	});
-
 /**
  * Size of each indentation step
Index: CKEditor/trunk/_source/plugins/selection/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/selection/plugin.js	(revision 5984)
+++ CKEditor/trunk/_source/plugins/selection/plugin.js	(revision 5985)
@@ -552,5 +552,5 @@
 		 * alert(ranges.length);
 		 */
-		getRanges : (function ()
+		getRanges : (function()
 		{
 			var func = CKEDITOR.env.ie ?