Index: CKEditor/branches/versions/3.5.x/CHANGES.html
===================================================================
--- CKEditor/branches/versions/3.5.x/CHANGES.html	(revision 6093)
+++ CKEditor/branches/versions/3.5.x/CHANGES.html	(revision 6100)
@@ -58,5 +58,6 @@
 		<li><a href="http://dev.ckeditor.com/ticket/5404">#5404</a> : Whitespaces (NBSP) were incorrectly added into empty table cells and list items.</li>
 		<li><a href="http://dev.ckeditor.com/ticket/5599">#5599</a> : Labels for special characters need to be resourced.</li>
-		<li><a href="http://dev.ckeditor.com/ticket/6419">#6419</a> : IE: List creation by merging problem.</li>
+		<li><a href="http:/dev.ckeditor.com/ticket/6419">#6419</a> : IE: List creation by merging problem.</li>
+		<li><a href="http:/dev.ckeditor.com/ticket/6502">#6502</a> : Remove IE6 image preloading.</li>
 		<li>Updated the following language files:<ul>
 			<li>Hebrew;</li>
Index: CKEditor/branches/versions/3.5.x/_source/core/imagecacher.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/core/imagecacher.js	(revision 6093)
+++ 	(revision )
@@ -1,80 +1,0 @@
-﻿/*
-Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
-For licensing, see LICENSE.html or http://ckeditor.com/license
-*/
-
-(function()
-{
-	var loaded = {};
-
-	var loadImage = function( image, callback )
-	{
-		var doCallback = function()
-			{
-				img.removeAllListeners();
-				loaded[ image ] = 1;
-				callback();
-			};
-
-		var img = new CKEDITOR.dom.element( 'img' );
-		img.on( 'load', doCallback );
-		img.on( 'error', doCallback );
-		img.setAttribute( 'src', image );
-	};
-
-	/**
-	 * @namespace Load images into the browser cache.
-	 */
- 	CKEDITOR.imageCacher =
-	{
-		/**
-		 * Loads one or more images.
-		 * @param {Array} images The URLs of the images to be loaded.
-		 * @param {Function} [callback] A function to be called once all images
-		 *		are loaded.
-		 * @return {CKEDITOR.event} An event object which fires the 'loaded'
-		 *		event when all images are completely loaded. Additionally, the
-		 *		"finished" property is set after the "loaded" event call.
-		 * @example
-		 * var loader = CKEDITOR.imageCacher.load( [ '/image1.png', 'image2.png' ] );
-		 * if ( !loader.finished )
-		 * {
-		 *     loader.on( 'load', function()
-		 *         {
-		 *             alert( 'All images are loaded' );
-		 *         });
-		 * }
-		 */
-		load : function( images, callback )
-		{
-			var pendingCount = images.length;
-
-			var event = new CKEDITOR.event;
-			event.on( 'loaded', function()
-				{
-					event.finished = 1;
-				});
-
-			if ( callback )
-				event.on( 'loaded', callback );
-
-			var checkPending = function()
-				{
-					if ( --pendingCount === 0 )
-						event.fire( 'loaded' );
-				};
-
-			for ( var i = 0 ; i < images.length ; i++ )
-			{
-				var image = images[ i ];
-
-				if ( loaded[ image ] )
-					checkPending();
-				else
-					loadImage( image, checkPending );
-			}
-
-			return event;
-		}
-	};
-})();
Index: CKEditor/branches/versions/3.5.x/_source/core/loader.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/core/loader.js	(revision 6093)
+++ CKEditor/branches/versions/3.5.x/_source/core/loader.js	(revision 6100)
@@ -60,10 +60,9 @@
 			'core/htmlparser/filter'	: [ 'core/htmlparser' ],
 			'core/htmlparser/basicwriter': [ 'core/htmlparser' ],
-			'core/imagecacher'		: [ 'core/dom/element', 'core/event' ],
 			'core/lang'				: [],
 			'core/plugins'			: [ 'core/resourcemanager' ],
 			'core/resourcemanager'	: [ 'core/scriptloader', 'core/tools' ],
 			'core/scriptloader'		: [ 'core/dom/element', 'core/env' ],
-			'core/skins'			: [ 'core/imagecacher', 'core/scriptloader' ],
+			'core/skins'			: [ 'core/scriptloader' ],
 			'core/themes'			: [ 'core/resourcemanager' ],
 			'core/tools'			: [ 'core/env' ],
Index: CKEditor/branches/versions/3.5.x/_source/core/skins.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/core/skins.js	(revision 6093)
+++ CKEditor/branches/versions/3.5.x/_source/core/skins.js	(revision 6100)
@@ -18,5 +18,4 @@
 	// Holds the list of loaded skins.
 	var loaded = {},
-		preloaded = {},
 		paths = {};
 
@@ -53,31 +52,4 @@
 							return 'url(' + baseUrl + opener +  path + closer + ')';
 					} );
-		}
-
-		// Check if we need to preload images from it.
-		var preload = skinDefinition.preload;
-		if ( preload && preload.length > 0 )
-		{
-			if ( !preloaded[ skinName ] )
-			{
-				// Prepare image URLs
-				appendSkinPath( preload );
-
-				// Get preloader event dispatcher object.
-				preloaded[ skinName ] = CKEDITOR.imageCacher.load( preload );
-			}
-
-			if ( !preloaded[ skinName ].finished )
-			{
-				// Bind listener for this editor instance.
-				preloaded[ skinName ].on( 'loaded', function()
-					{
-						loadPart( editor, skinName, part, callback );
-					}
-				);
-
-				// Execution will be continued from event listener.
-				return;
-			}
 		}
 
Index: CKEditor/branches/versions/3.5.x/_source/skins/kama/skin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/skins/kama/skin.js	(revision 6093)
+++ CKEditor/branches/versions/3.5.x/_source/skins/kama/skin.js	(revision 6100)
@@ -6,16 +6,7 @@
 CKEDITOR.skins.add( 'kama', (function()
 {
-	var preload = [],
-		uiColorStylesheetId = 'cke_ui_color';
-
-	if ( CKEDITOR.env.ie && CKEDITOR.env.version < 7 )
-	{
-		// For IE6, we need to preload some images, otherwhise they will be
-		// downloaded several times (CSS background bug).
-		preload.push( 'icons.png', 'images/sprites_ie6.png', 'images/dialog_sides.gif' );
-	}
+	var uiColorStylesheetId = 'cke_ui_color';
 
 	return {
-		preload		: preload,
 		editor		: { css : [ 'editor.css' ] },
 		dialog		: { css : [ 'dialog.css' ] },
Index: CKEditor/branches/versions/3.5.x/_source/skins/office2003/skin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/skins/office2003/skin.js	(revision 6093)
+++ CKEditor/branches/versions/3.5.x/_source/skins/office2003/skin.js	(revision 6100)
@@ -6,15 +6,5 @@
 CKEDITOR.skins.add( 'office2003', (function()
 {
-	var preload = [];
-
-	if ( CKEDITOR.env.ie && CKEDITOR.env.version < 7 )
-	{
-		// For IE6, we need to preload some images, otherwhise they will be
-		// downloaded several times (CSS background bug).
-		preload.push( 'icons.png', 'images/sprites_ie6.png', 'images/dialog_sides.gif' );
-	}
-
 	return {
-		preload		: preload,
 		editor		: { css : [ 'editor.css' ] },
 		dialog		: { css : [ 'dialog.css' ] },
Index: CKEditor/branches/versions/3.5.x/_source/skins/v2/skin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/skins/v2/skin.js	(revision 6093)
+++ CKEditor/branches/versions/3.5.x/_source/skins/v2/skin.js	(revision 6100)
@@ -6,15 +6,5 @@
 CKEDITOR.skins.add( 'v2', (function()
 {
-	var preload = [];
-
-	if ( CKEDITOR.env.ie && CKEDITOR.env.version < 7 )
-	{
-		// For IE6, we need to preload some images, otherwhise they will be
-		// downloaded several times (CSS background bug).
-		preload.push( 'icons.png', 'images/sprites_ie6.png', 'images/dialog_sides.gif' );
-	}
-
 	return {
-		preload		: preload,
 		editor		: { css : [ 'editor.css' ] },
 		dialog		: { css : [ 'dialog.css' ] },
Index: CKEditor/branches/versions/3.5.x/ckeditor.pack
===================================================================
--- CKEditor/branches/versions/3.5.x/ckeditor.pack	(revision 6093)
+++ CKEditor/branches/versions/3.5.x/ckeditor.pack	(revision 6100)
@@ -110,5 +110,4 @@
 					'_source/core/resourcemanager.js',
 					'_source/core/plugins.js',
-					'_source/core/imagecacher.js',
 					'_source/core/skins.js',
 					'_source/core/themes.js',