Index: CKEditor/branches/features/adobeair/_source/plugins/adobeair/assets/air_boostrap_frame.html
===================================================================
--- CKEditor/branches/features/adobeair/_source/plugins/adobeair/assets/air_boostrap_frame.html	(revision 6148)
+++ CKEditor/branches/features/adobeair/_source/plugins/adobeair/assets/air_boostrap_frame.html	(revision 6149)
@@ -1,5 +1,7 @@
-<script id="cke_air_bootscript">
-	document.write( window.parent.CKEDITOR._[ 'air_bootstrap_data' + location.search.substring( 1 ) ] || '' );
-	var me = document.getElementById( "cke_air_bootscript" );
-		me.parentNode.removeChild( me );
+<script id="cke_air_bootscript" type="text/javascript">
+
+document.write( window.parent.CKEDITOR._[ 'air_bootstrap_data' + location.search.substring(1) ] || '' );
+var me = document.getElementById( 'cke_air_bootscript' );
+me.parentNode.removeChild( me );
+
 </script>
Index: CKEditor/branches/features/adobeair/_source/plugins/elementspath/plugin.js
===================================================================
--- CKEditor/branches/features/adobeair/_source/plugins/elementspath/plugin.js	(revision 6148)
+++ CKEditor/branches/features/adobeair/_source/plugins/elementspath/plugin.js	(revision 6149)
@@ -64,45 +64,43 @@
 			}
 
-			var onClickHanlder = CKEDITOR.tools.addFunction( onClick ),
-					onKeydownHandler= CKEDITOR.tools.addFunction( function( elementIndex, ev )
+			var onClickHanlder = CKEDITOR.tools.addFunction( onClick );
+
+			var onKeyDownHandler = CKEDITOR.tools.addFunction( function( elementIndex, ev )
+				{
+					var idBase = editor._.elementsPath.idBase,
+						element;
+
+					ev = new CKEDITOR.dom.event( ev );
+
+					var rtl = editor.lang.dir == 'rtl';
+					switch ( ev.getKeystroke() )
 					{
-						var idBase = editor._.elementsPath.idBase,
-							element;
+						case rtl ? 39 : 37 :		// LEFT-ARROW
+						case 9 :					// TAB
+							element = CKEDITOR.document.getById( idBase + ( elementIndex + 1 ) );
+							if ( !element )
+								element = CKEDITOR.document.getById( idBase + '0' );
+							element.focus();
+							return false;
 
-						ev = new CKEDITOR.dom.event( ev );
+						case rtl ? 37 : 39 :		// RIGHT-ARROW
+						case CKEDITOR.SHIFT + 9 :	// SHIFT + TAB
+							element = CKEDITOR.document.getById( idBase + ( elementIndex - 1 ) );
+							if ( !element )
+								element = CKEDITOR.document.getById( idBase + ( editor._.elementsPath.list.length - 1 ) );
+							element.focus();
+							return false;
 
-						var rtl = editor.lang.dir == 'rtl';
-						switch ( ev.getKeystroke() )
-						{
-						 case rtl ? 39 : 37 :					// LEFT-ARROW
-						 case 9 :					// TAB
-						  element = CKEDITOR.document.getById( idBase + ( elementIndex + 1 ) );
-						  if ( !element )
-							  element = CKEDITOR.document.getById( idBase + '0' );
-						  element.focus();
-						  return false;
+						case 27 :					// ESC
+							editor.focus();
+							return false;
 
-						 case rtl ? 37 : 39 :					// RIGHT-ARROW
-						 case CKEDITOR.SHIFT + 9 :	// SHIFT + TAB
-						  element = CKEDITOR.document.getById( idBase + ( elementIndex - 1 ) );
-						  if ( !element )
-							  element = CKEDITOR.document.getById( idBase + ( editor._.elementsPath.list.length - 1 ) );
-						  element.focus();
-						  return false;
-
-						 case 27 :					// ESC
-						  editor.focus();
-						  return false;
-
-						 case 13 :					// ENTER	// Opera
-						 case 32 :					// SPACE
-						  onClick( elementIndex );
-						  return false;
-
-						 //default :
-						 //	alert( ev.getKeystroke() );
-						}
-						return true;
-					});
+						case 13 :					// ENTER	// Opera
+						case 32 :					// SPACE
+							onClick( elementIndex );
+							return false;
+					}
+					return true;
+				});
 
 			editor.on( 'selectionChange', function( ev )
@@ -162,5 +160,5 @@
 									' onfocus="event.preventBubble();"' : '' ) +
 									' hidefocus="true" ' +
-									' onkeydown="return CKEDITOR.tools.callFunction(', onKeydownHandler, ',', index, ', event );"' +
+									' onkeydown="return CKEDITOR.tools.callFunction(', onKeyDownHandler, ',', index, ', event );"' +
 									extra ,
 									' onclick="CKEDITOR.tools.callFunction('+ onClickHanlder, ',', index, '); return false;"',
Index: CKEditor/branches/features/adobeair/_source/themes/default/theme.js
===================================================================
--- CKEditor/branches/features/adobeair/_source/themes/default/theme.js	(revision 6148)
+++ CKEditor/branches/features/adobeair/_source/themes/default/theme.js	(revision 6149)
@@ -163,5 +163,5 @@
 
 			// Redirect the focus into editor for webkit. (#5713)
-			CKEDITOR.env.webkit && editor.container.on( 'focus', function() { editor.focus(); } );
+			CKEDITOR.env.webkit && container.on( 'focus', function() { editor.focus(); } );
 
 			// Disable browser context menu for editor's chrome.